searchData={"items":[{"type":"module","title":"PrometheusExometer","doc":"Interface functions which publish Exometer metrics in Prometheus format.","ref":"PrometheusExometer.html"},{"type":"function","title":"PrometheusExometer.exports_prometheus_convert_name?/1","doc":"Return true if module exports an `prometheus_convert_name` callback function","ref":"PrometheusExometer.html#exports_prometheus_convert_name?/1"},{"type":"function","title":"PrometheusExometer.get_converters/1","doc":"Filter list of modules to ones with a `prometheus_convert_name` callback","ref":"PrometheusExometer.html#get_converters/1"},{"type":"function","title":"PrometheusExometer.scrape/0","doc":"Scrape with default config","ref":"PrometheusExometer.html#scrape/0"},{"type":"function","title":"PrometheusExometer.scrape/1","doc":"Format data from Exometer metrics in Prometheus text format.\n\nIt takes a map with configuration options.\n\nconfig = %{namespace: list(atom), converters: list(module)}\n\nKeys:\n\n- `namespace`: a prefix which will be added to each metric, normally the app name\n- `converters`: a list of modules which have callback functions to convert\n    internal Exometer names into external format","ref":"PrometheusExometer.html#scrape/1"},{"type":"module","title":"PrometheusExometer.Metrics","doc":"Interface functions to update Exometer metrics with labels.\n\nThe underlying [Exometer\nAPI](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Setting_metric_values)\nto set values is simple. It doesn't change depending on the type of the\nmetric, you can call the `update/3` function for everything. This function is a simple\nwrapper which calls `combine_name_labels/2` on its arguments, then calls\n`:exometer.update_or_create/2`. Calling e.g. `inc/3` if you are incrementing\na counter makes the intent clearer, though.\n\nThere are convenience functions to help with duration calculations as well.\n\nThis interface largely implements the [recommended public API for Prometheus\nclient libraries](https://prometheus.io/docs/instrumenting/writing_clientlibs/)\n\nDifferences with the Prometheus API recommendations:\n\nErlang handles times in microseconds internally, so that's what we store, and\nthat's the default output unit instead of seconds.","ref":"PrometheusExometer.Metrics.html"},{"type":"function","title":"PrometheusExometer.Metrics.combine_name_labels/2","doc":"Combine base metric name with labels.","ref":"PrometheusExometer.Metrics.html#combine_name_labels/2"},{"type":"function","title":"PrometheusExometer.Metrics.dec/1","doc":"","ref":"PrometheusExometer.Metrics.html#dec/1"},{"type":"function","title":"PrometheusExometer.Metrics.dec/2","doc":"","ref":"PrometheusExometer.Metrics.html#dec/2"},{"type":"function","title":"PrometheusExometer.Metrics.dec/3","doc":"Decrement counter or gauge metric.\n\nReturns `:ok`.","ref":"PrometheusExometer.Metrics.html#dec/3"},{"type":"function","title":"Examples - PrometheusExometer.Metrics.dec/3","doc":"iex> PrometheusExometer.Metrics.dec([:active_requests])\n    :ok","ref":"PrometheusExometer.Metrics.html#dec/3-examples"},{"type":"function","title":"PrometheusExometer.Metrics.ensure_child/2","doc":"Ensure that a metric exists with the specified keyword under the parent metric","ref":"PrometheusExometer.Metrics.html#ensure_child/2"},{"type":"function","title":"PrometheusExometer.Metrics.get_value/1","doc":"Get Exometer metric value","ref":"PrometheusExometer.Metrics.html#get_value/1"},{"type":"function","title":"PrometheusExometer.Metrics.get_value/2","doc":"Get Exometer metric value with labels","ref":"PrometheusExometer.Metrics.html#get_value/2"},{"type":"function","title":"PrometheusExometer.Metrics.inc/1","doc":"","ref":"PrometheusExometer.Metrics.html#inc/1"},{"type":"function","title":"PrometheusExometer.Metrics.inc/2","doc":"","ref":"PrometheusExometer.Metrics.html#inc/2"},{"type":"function","title":"PrometheusExometer.Metrics.inc/3","doc":"Increment counter or gauge metric.\n\nReturns `:ok`.","ref":"PrometheusExometer.Metrics.html#inc/3"},{"type":"function","title":"Examples - PrometheusExometer.Metrics.inc/3","doc":"Increment simple `requests` metric by one:\n\n    iex> PrometheusExometer.Metrics.inc([:requests])\n    :ok","ref":"PrometheusExometer.Metrics.html#inc/3-examples"},{"type":"function","title":"PrometheusExometer.Metrics.observe/2","doc":"","ref":"PrometheusExometer.Metrics.html#observe/2"},{"type":"function","title":"PrometheusExometer.Metrics.observe/3","doc":"Observe current value for histogram or summary.","ref":"PrometheusExometer.Metrics.html#observe/3"},{"type":"function","title":"PrometheusExometer.Metrics.observe_duration/2","doc":"Observe time difference in ms between starting time and current time.","ref":"PrometheusExometer.Metrics.html#observe_duration/2"},{"type":"function","title":"PrometheusExometer.Metrics.observe_duration/3","doc":"","ref":"PrometheusExometer.Metrics.html#observe_duration/3"},{"type":"function","title":"PrometheusExometer.Metrics.set/2","doc":"","ref":"PrometheusExometer.Metrics.html#set/2"},{"type":"function","title":"PrometheusExometer.Metrics.set/3","doc":"Set gauge to specified value.\n\nReturns `:ok`.","ref":"PrometheusExometer.Metrics.html#set/3"},{"type":"function","title":"Examples - PrometheusExometer.Metrics.set/3","doc":"iex> PrometheusExometer.Metrics.set([:records], 1000)\n    :ok","ref":"PrometheusExometer.Metrics.html#set/3-examples"},{"type":"function","title":"PrometheusExometer.Metrics.set_duration/2","doc":"Set metric to the difference between the specified timestamp and the current time in ms.\n\nReturns `:ok`.","ref":"PrometheusExometer.Metrics.html#set_duration/2"},{"type":"function","title":"Examples - PrometheusExometer.Metrics.set_duration/2","doc":"start_time = :os.timestamp()\n    do_some_work()\n    PrometheusExometer.Metrics.set_duration([:duration], start_time)","ref":"PrometheusExometer.Metrics.html#set_duration/2-examples"},{"type":"function","title":"PrometheusExometer.Metrics.set_duration/3","doc":"","ref":"PrometheusExometer.Metrics.html#set_duration/3"},{"type":"function","title":"PrometheusExometer.Metrics.set_to_current_time/1","doc":"","ref":"PrometheusExometer.Metrics.html#set_to_current_time/1"},{"type":"function","title":"PrometheusExometer.Metrics.set_to_current_time/2","doc":"Set metric to the current Unix time in seconds.","ref":"PrometheusExometer.Metrics.html#set_to_current_time/2"},{"type":"function","title":"PrometheusExometer.Metrics.tc/4","doc":"Record duration in ms of a function call, like Erlang :timer.tc/3","ref":"PrometheusExometer.Metrics.html#tc/4"},{"type":"function","title":"PrometheusExometer.Metrics.tc/5","doc":"","ref":"PrometheusExometer.Metrics.html#tc/5"},{"type":"function","title":"PrometheusExometer.Metrics.update/2","doc":"","ref":"PrometheusExometer.Metrics.html#update/2"},{"type":"function","title":"PrometheusExometer.Metrics.update/3","doc":"Update Exometer metric with labels","ref":"PrometheusExometer.Metrics.html#update/3"},{"type":"type","title":"PrometheusExometer.Metrics.error/0","doc":"","ref":"PrometheusExometer.Metrics.html#t:error/0"},{"type":"type","title":"PrometheusExometer.Metrics.labels/0","doc":"","ref":"PrometheusExometer.Metrics.html#t:labels/0"},{"type":"type","title":"PrometheusExometer.Metrics.name/0","doc":"","ref":"PrometheusExometer.Metrics.html#t:name/0"},{"type":"type","title":"PrometheusExometer.Metrics.value/0","doc":"","ref":"PrometheusExometer.Metrics.html#t:value/0"},{"type":"module","title":"PrometheusExometer.SampleMetrics","doc":"Collect metrics by calling functions","ref":"PrometheusExometer.SampleMetrics.html"},{"type":"function","title":"PrometheusExometer.SampleMetrics.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"PrometheusExometer.SampleMetrics.html#child_spec/1"},{"type":"function","title":"PrometheusExometer.SampleMetrics.start_link/2","doc":"Start the sampler server","ref":"PrometheusExometer.SampleMetrics.html#start_link/2"},{"type":"extras","title":"prometheus_exometer","doc":"# prometheus_exometer\n\nThis library adds support to [Exometer](https://github.com/Feuerlabs/exometer_core)\nto generate [Prometheus](https://prometheus.io/) metrics output. It reads the\nExometer metrics you define and generates a report in text format.\n\nIn a minimal system, you can set up a [Cowboy](https://github.com/ninenines/cowboy)\nhandler to respond to metrics requests, or you can add a route/endpoint to\n[Phoenix](http://phoenixframework.org/).\n\nThis module supports the standard Exometer probe types such as counter,\nas well as using [labels](https://prometheus.io/docs/concepts/data_model/#metric-names-and-labels),\nwhich is more natural for Prometheus, e.g..\n\n    api_http_requests_total{method=\"POST\", handler=\"/messages\"}\n\nIt does this by converting the labels into keyword=value atoms which it appends to the\nExometer name, which is normally a list of atoms. The Erlang VM has a relatively small fixed\nlimit on the number of atoms. Because of this, you should not create labels in response to\nexternal input, you should limit the atoms to a relatively small set that you control.","ref":"readme.html"},{"type":"extras","title":"Example - prometheus_exometer","doc":"An example of creating metrics is to record atom codes for handler,\naction, and detail on responses. The handler indicates the module which created\nthe response. The action is a standard set like \"success\", \"redirect\",\n\"reject\", \"error\", similar to HTTP 200/300/400/500 responses. Detail depends on the module,\ne.g. if we reject DDOS traffic based on the HTTP user agent, it might be\n\"agent.\n\nThe result might look something like this for an API service:\n\n    # HELP api_responses Total number of responses\n    # TYPE api_responses counter\n    api_responses{handler=\"rate_limit\",action=\"reject\",detail=\"ip\"} 480\n    api_responses{handler=\"validate\",action=\"invalid\",detail=\"user\"} 7\n    api_responses{handler=\"block_media\",action=\"reject\",detail=\"media\"} 100\n    api_responses{handler=\"db\",action=\"invalid\",detail=\"unknown\"} 20\n    api_responses{handler=\"route\",action=\"redirect\",detail=\"legacy\"} 10\n    api_responses{handler=\"api\",action=\"success\",detail=\"ok\"} 1000","ref":"readme.html#example"},{"type":"extras","title":"Prometheus histograms vs Exometer histograms - prometheus_exometer","doc":"There is a fundamental difference between Exometer histograms and Exometer histograms.\nExometer histogram buckets are dynamic, so when you get e.g. the 95% bucket, it depends\non the actual samples. Prometheus histograms have a static range, and are perhaps best\nthought of as having multiple counters, one for each bucket. Because of this, we need\nto predefine the bucket ranges that we will use.","ref":"readme.html#prometheus-histograms-vs-exometer-histograms"},{"type":"extras","title":"Installation - prometheus_exometer","doc":"Add `prometheus_exometer` to your list of deps in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:prometheus_exometer, github: \"cogini/prometheus_exometer\"},\n  ]\nend\n```\nThis will pull in Exometer and its dependencies.\n\nConfigure Exometer to use the custom\n[probes](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Built-in_entries_and_probes)\ndefined in this module, e.g. in `config/config.exs`.\n\n```elixir\nconfig :exometer_core,\n  defaults: [\n    {[:_], :history, [module: :exometer_folsom]},\n    {[:_], :prometheus_counter, [module: :prometheus_exometer_counter]},\n    {[:_], :prometheus_gauge, [module: :prometheus_exometer_gauge]},\n    {[:_], :prometheus_histogram, [module: :prometheus_exometer_histogram,\n      options: [time_span: 300_000, truncate: :false, histogram_module: :exometer_slide, keep_high: 100,\n                prometheus: %{export_buckets: :true}\n               ],\n    ]},\n    {[:_], :histogram, [module: :exometer_histogram,\n      options: [time_span: 300_000, truncate: :false, histogram_module: :exometer_slide, keep_high: 100,\n                prometheus: %{export_quantiles: :true}\n              ],\n    ]},\n  ],\n  predefined: [\n    {[:duration], :prometheus_histogram, [prometheus: %{\n        description: \"Time to create response\",\n        unit: :us, suffix: :us, export_buckets: :true,\n        buckets: [100, 250, 500, 750, 1000, 5000, 10_000, 25_000, 50_000, 75_000, 100_000,\n                  500_000, 750_000, 1_000_000, 1_500_000, 2_000_000, 2_100_000, 2_500_000],\n    }]},\n    {[:requests], :prometheus_counter, [prometheus: %{description: \"Total number of requests\"}]},\n    {[:responses], :prometheus_counter, [prometheus: %{description: \"Total number of responses\"}]},\n  ]\n```","ref":"readme.html#installation"},{"type":"extras","title":"Defining metrics - prometheus_exometer","doc":"While it's possible to define Exometer metrics programmatically in your code,\ndue to the loose relationship between independent Erlang applications, it's\neasy to get into race conditions on startup. Defining metrics is in\n`predefined` section of the `exometer_core` config generally works well, though\nthe syntax is a bit messy.\n\nIn order to make things more resilient, the metrics recording functions in this\nlibrary call `:exometer.update_or_create/2`. The effect is that the metric will\nbe created the first time it is used based on the settings in the\n`defaults` section of the `exometer_core` config.\n\nIf you have specific settings that you want, e.g. histogram buckets, then you\nshould define the metric before you use it, either in the `predefined` section\nor in your application initialization.\n\nFollowing is an example Cowboy \"middleware\" which uses an init function to\ncreate metrics. It uses the low level `:exometer.update/2` since it knows that the\nmetrics are there, though `PrometheusMiddleware.Metrics.update/2` would work as well.\n\n```elixir\ndefmodule Foo.Middleware do\n  @moduledoc \"Cowboy middleware which records metrics\"\n  require Logger\n\n  alias PrometheusMiddleware.Metrics\n\n  @behaviour :cowboy_middleware\n\n  @metric_http_requests [:cowboy, :http, :requests]\n  @metric_http_responses [:cowboy, :http, :responses]\n  @metric_http_active [:cowboy, :http, :active]\n  @metric_http_errors [:cowboy, :http, :errors]\n  @metric_http_duration [:cowboy, :http, :duration]\n\n  # https://en.wikipedia.org/wiki/List_of_HTTP_status_codes\n  @status_codes [200, 201, 202, 203, 204, 205, 206,\n                 300, 301, 302, 303, 304, 305, 306, 307, 308,\n                 400, 401, 402, 403, 404, 405, 406, 407, 408, 409, 410,\n                 411, 412, 413, 414, 415, 416, 417, 418, 419, 421, 426,\n                 428, 429, 431, 451,\n                 500, 501, 502, 503, 504, 505, 506, 511]\n\n  # Called once by Cowboy on startup\n  def init do\n    # Logger.debug(\"Creating Exometer metrics\")\n    :ok = :exometer.ensure(@metric_http_requests, :counter, prometheus: %{\n                             description: \"Total http requests\"\n                           })\n\n    :ok = :exometer.ensure(@metric_http_responses, :prometheus_counter, prometheus: %{\n                             description: \"Total responses by code\"\n                           })\n\n    # Create metrics for each of the status codes\n    # TODO: the code is actually a string, e.g. \"200 OK\", so this doesn't really work\n    for code <- @status_codes do\n      Metrics.ensure_child(@metric_http_responses, code: code)\n    end\n\n    :ok = :exometer.ensure(@metric_http_errors, :counter, prometheus: %{\n                             description: \"Total errors (5xx)\"\n                           })\n\n    :ok = :exometer.ensure(@metric_http_invalid_qs, :counter, prometheus: %{\n                             description: \"Total requests with invalid query string\"\n\n    # This is a counter instead of a guage to get atomic increment/decrement\n    # semantics. It's not accurate in the case of Cowboy, as the hook functions don't get\n    # called in case of errors, but is here as an example of how to use the metrics functions.\n    :ok = :exometer.ensure(@metric_http_active, :counter, prometheus: %{\n                             description: \"Instantaneous active requests\",\n                             type: :gauge\n                           })\n\n    :ok = :exometer.ensure(@metric_http_duration, :prometheus_histogram,\n                           prometheus: %{\n                             description: \"Total processing duration\",\n                             unit: :us, suffix: :us,\n                             export_buckets: :true,\n                             buckets: [100, 250, 500, 750, 1000, 5000,\n                                       10_000, 25_000, 50_000, 75_000,\n                                       100_000, 500_000, 750_000, 1_000_000,\n                                       1_500_000, 2_000_000, 2_100_000],\n                           },\n                           time_span: 300_000, truncate: false)\n\n    :ok\n  end\n\n  # Called at start of valid request\n  # It will not be called on e.g. HTTP parse errors, though the response hook will be\n  def execute(req, env) do\n    # Logger.debug(\"execute: #{inspect req} #{inspect env}\")\n    :exometer.update(@metric_http_requests, 1)\n    :exometer.update(@metric_http_active, 1)\n\n    # Set start time of the request\n    req = :cowboy_req.set_meta(:foo_start_time, :os.timestamp(), req)\n\n    {:ok, req, env}\n  end\n\n  # Called at end of request\n  def cowboy_response_hook(code, headers, body, req) do\n    # code may be an integer or a string like \"200 OK\"\n    code = get_code(code)\n\n    :exometer.update(@metric_http_responses, {[code: code], 1})\n\n    if code >= 500 and code < 600 do\n      :exometer.update(@metric_http_errors, 1)\n    end\n\n    {start_time, req} = :cowboy_req.meta(:foo_start_time, req)\n    case start_time do\n      :undefined -> :ok\n      _ ->\n        Metrics.observe_duration(@metric_http_duration, start_time)\n        :exometer.update(@metric_http_active, -1)\n    end\n    # Logger.debug(\"cowboy_response_hook: end #{code} #{inspect req2} #{inspect stats()}\")\n\n    # Pretend to be nginx\n    headers2 = :lists.keyreplace(\"server\", 1, headers, {\"server\", \"nginx\"})\n    {:ok, req} = :cowboy_req.reply(code, headers2, body, req)\n    req\n  end\n\n  @spec get_code(non_neg_integer | binary) :: non_neg_integer\n  defp get_code(code) when is_integer(code), do: code\n  defp get_code(code) when is_binary(code) do\n    # code may be string like \"200 OK\"\n    code = hd(String.split(code))\n    String.to_integer(code)\n  end\n\nend\n```\n\n```\n# HELP api_cowboy_http_active Instantaneous active requests\n# TYPE api_cowboy_http_active gauge\napi_cowboy_http_active 0\n# HELP api_cowboy_http_duration_us Total processing duration\n# TYPE api_cowboy_http_duration_us histogram\napi_cowboy_http_duration_us{le=\"100\"} 0\napi_cowboy_http_duration_us{le=\"250\"} 0\napi_cowboy_http_duration_us{le=\"500\"} 0\napi_cowboy_http_duration_us{le=\"750\"} 0\napi_cowboy_http_duration_us{le=\"1000\"} 0\napi_cowboy_http_duration_us{le=\"5000\"} 0\napi_cowboy_http_duration_us{le=\"10000\"} 32\napi_cowboy_http_duration_us{le=\"25000\"} 77\napi_cowboy_http_duration_us{le=\"50000\"} 78\napi_cowboy_http_duration_us{le=\"75000\"} 78\napi_cowboy_http_duration_us{le=\"100000\"} 78\napi_cowboy_http_duration_us{le=\"500000\"} 103\napi_cowboy_http_duration_us{le=\"750000\"} 107\napi_cowboy_http_duration_us{le=\"1000000\"} 107\napi_cowboy_http_duration_us{le=\"1500000\"} 107\napi_cowboy_http_duration_us{le=\"2000000\"} 107\napi_cowboy_http_duration_us{le=\"2100000\"} 107\napi_cowboy_http_duration_us{le=\"+Inf\"} 107\napi_cowboy_http_duration_us_sum 13563467\napi_cowboy_http_duration_us_count 107\n# HELP api_cowboy_http_errors Total errors (5xx)\n# TYPE api_cowboy_http_errors counter\napi_cowboy_http_errors 0\n# HELP api_cowboy_http_requests Total http requests\n# TYPE api_cowboy_http_requests counter\napi_cowboy_http_requests 107\n# HELP api_cowboy_http_responses Total responses by code\n# TYPE api_cowboy_http_responses counter\napi_cowboy_http_responses 0\napi_cowboy_http_responses{code=\"200 OK\"} 49\napi_cowboy_http_responses{code=\"302 Found\"} 48\napi_cowboy_http_responses{code=\"404 Not Found\"} 10\n```\n\n# Sampling metrics\n\n`PrometheusExometer.SampleMetrics` is a GenServer which periodically updates metrics by calling functions.\n\nPut this in `config/config.exs`:\n\n```elixir\nconfig :foo,\n  sample_metrics: [\n    sample_interval: 60_000,\n    metrics: [\n      {[:erlang, :memory, :total], {:erlang, :memory, [:total]}},\n      {[:erlang, :memory, :processes], {:erlang, :memory, [:processes]}},\n      {[:erlang, :memory, :processes_used], {:erlang, :memory, [:processes_used]}},\n      {[:erlang, :memory, :system], {:erlang, :memory, [:system]}},\n      {[:erlang, :memory, :atom], {:erlang, :memory, [:atom]}},\n      {[:erlang, :memory, :atom_used], {:erlang, :memory, [:atom_used]}},\n      {[:erlang, :memory, :binary], {:erlang, :memory, [:binary]}},\n      {[:erlang, :memory, :ets], {:erlang, :memory, [:ets]}},\n      {[:erlang, :system_info, :process_count], {:erlang, :system_info, [:process_count]}},\n      {[:erlang, :system_info, :port_count], {:erlang, :system_info, [:port_count]}},\n      {[:erlang, :statistics, :run_queue], {:erlang, :statistics, [:run_queue]}},\n    ]\n  ]\n\nconfig :foo,\n  exometer_predefined: [\n      {[:erlang, :memory, :total], :gauge, []},\n      {[:erlang, :memory, :processes], :gauge, []},\n      {[:erlang, :memory, :processes_used], :gauge, []},\n      {[:erlang, :memory, :system], :gauge, []},\n      {[:erlang, :memory, :atom], :gauge, []},\n      {[:erlang, :memory, :atom_used], :gauge, []},\n      {[:erlang, :memory, :binary], :gauge, []},\n      {[:erlang, :memory, :ets], :gauge, []},\n      {[:erlang, :system_info, :process_count], :gauge, []},\n      {[:erlang, :system_info, :port_count], :gauge, []},\n      {[:erlang, :statistics, :run_queue], :gauge, []},\n  ]\n```\n\nConfigure and start it in your application supervisor:\n\n```elixir\ndef start(_type, _args) do\n  import Supervisor.Spec\n\n  sample_metrics_opts = Application.get_env(:foo, :sample_metrics, [])\n\n  children = [\n    {PrometheusExometer.SampleMetrics, [sample_metrics_opts]},\n  ]\n\n  opts = [strategy: :one_for_one, name: Foo.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```","ref":"readme.html#defining-metrics"},{"type":"extras","title":"Changelog","doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [0.3.1] - 2024-07-13","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Upgrade libraries\n\n## [0.3.0] - 2024-04-17","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Upgrade libraries\n\n## [0.2.0] - 2020-01-24","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Catch transient badarg errors from ets","ref":"changelog.html#added"},{"type":"extras","title":"License (Mozilla Public License 2.0)","doc":"Mozilla Public License Version 2.0\n==================================\n\n1. Definitions\n--------------\n\n1.1. \"Contributor\"\n    means each individual or legal entity that creates, contributes to\n    the creation of, or owns Covered Software.\n\n1.2. \"Contributor Version\"\n    means the combination of the Contributions of others (if any) used\n    by a Contributor and that particular Contributor's Contribution.\n\n1.3. \"Contribution\"\n    means Covered Software of a particular Contributor.\n\n1.4. \"Covered Software\"\n    means Source Code Form to which the initial Contributor has attached\n    the notice in Exhibit A, the Executable Form of such Source Code\n    Form, and Modifications of such Source Code Form, in each case\n    including portions thereof.\n\n1.5. \"Incompatible With Secondary Licenses\"\n    means\n\n    (a) that the initial Contributor has attached the notice described\n        in Exhibit B to the Covered Software; or\n\n    (b) that the Covered Software was made available under the terms of\n        version 1.1 or earlier of the License, but not also under the\n        terms of a Secondary License.\n\n1.6. \"Executable Form\"\n    means any form of the work other than Source Code Form.\n\n1.7. \"Larger Work\"\n    means a work that combines Covered Software with other material, in\n    a separate file or files, that is not Covered Software.\n\n1.8. \"License\"\n    means this document.\n\n1.9. \"Licensable\"\n    means having the right to grant, to the maximum extent possible,\n    whether at the time of the initial grant or subsequently, any and\n    all of the rights conveyed by this License.\n\n1.10. \"Modifications\"\n    means any of the following:\n\n    (a) any file in Source Code Form that results from an addition to,\n        deletion from, or modification of the contents of Covered\n        Software; or\n\n    (b) any new file in Source Code Form that contains any Covered\n        Software.\n\n1.11. \"Patent Claims\" of a Contributor\n    means any patent claim(s), including without limitation, method,\n    process, and apparatus claims, in any patent Licensable by such\n    Contributor that would be infringed, but for the grant of the\n    License, by the making, using, selling, offering for sale, having\n    made, import, or transfer of either its Contributions or its\n    Contributor Version.\n\n1.12. \"Secondary License\"\n    means either the GNU General Public License, Version 2.0, the GNU\n    Lesser General Public License, Version 2.1, the GNU Affero General\n    Public License, Version 3.0, or any later versions of those\n    licenses.\n\n1.13. \"Source Code Form\"\n    means the form of the work preferred for making modifications.\n\n1.14. \"You\" (or \"Your\")\n    means an individual or a legal entity exercising rights under this\n    License. For legal entities, \"You\" includes any entity that\n    controls, is controlled by, or is under common control with You. For\n    purposes of this definition, \"control\" means (a) the power, direct\n    or indirect, to cause the direction or management of such entity,\n    whether by contract or otherwise, or (b) ownership of more than\n    fifty percent (50%) of the outstanding shares or beneficial\n    ownership of such entity.\n\n2. License Grants and Conditions\n--------------------------------\n\n2.1. Grants\n\nEach Contributor hereby grants You a world-wide, royalty-free,\nnon-exclusive license:\n\n(a) under intellectual property rights (other than patent or trademark)\n    Licensable by such Contributor to use, reproduce, make available,\n    modify, display, perform, distribute, and otherwise exploit its\n    Contributions, either on an unmodified basis, with Modifications, or\n    as part of a Larger Work; and\n\n(b) under Patent Claims of such Contributor to make, use, sell, offer\n    for sale, have made, import, and otherwise transfer either its\n    Contributions or its Contributor Version.\n\n2.2. Effective Date\n\nThe licenses granted in Section 2.1 with respect to any Contribution\nbecome effective for each Contribution on the date the Contributor first\ndistributes such Contribution.\n\n2.3. Limitations on Grant Scope\n\nThe licenses granted in this Section 2 are the only rights granted under\nthis License. No additional rights or licenses will be implied from the\ndistribution or licensing of Covered Software under this License.\nNotwithstanding Section 2.1(b) above, no patent license is granted by a\nContributor:\n\n(a) for any code that a Contributor has removed from Covered Software;\n    or\n\n(b) for infringements caused by: (i) Your and any other third party's\n    modifications of Covered Software, or (ii) the combination of its\n    Contributions with other software (except as part of its Contributor\n    Version); or\n\n(c) under Patent Claims infringed by Covered Software in the absence of\n    its Contributions.\n\nThis License does not grant any rights in the trademarks, service marks,\nor logos of any Contributor (except as may be necessary to comply with\nthe notice requirements in Section 3.4).\n\n2.4. Subsequent Licenses\n\nNo Contributor makes additional grants as a result of Your choice to\ndistribute the Covered Software under a subsequent version of this\nLicense (see Section 10.2) or under the terms of a Secondary License (if\npermitted under the terms of Section 3.3).\n\n2.5. Representation\n\nEach Contributor represents that the Contributor believes its\nContributions are its original creation(s) or it has sufficient rights\nto grant the rights to its Contributions conveyed by this License.\n\n2.6. Fair Use\n\nThis License is not intended to limit any rights You have under\napplicable copyright doctrines of fair use, fair dealing, or other\nequivalents.\n\n2.7. Conditions\n\nSections 3.1, 3.2, 3.3, and 3.4 are conditions of the licenses granted\nin Section 2.1.\n\n3. Responsibilities\n-------------------\n\n3.1. Distribution of Source Form\n\nAll distribution of Covered Software in Source Code Form, including any\nModifications that You create or to which You contribute, must be under\nthe terms of this License. You must inform recipients that the Source\nCode Form of the Covered Software is governed by the terms of this\nLicense, and how they can obtain a copy of this License. You may not\nattempt to alter or restrict the recipients' rights in the Source Code\nForm.\n\n3.2. Distribution of Executable Form\n\nIf You distribute Covered Software in Executable Form then:\n\n(a) such Covered Software must also be made available in Source Code\n    Form, as described in Section 3.1, and You must inform recipients of\n    the Executable Form how they can obtain a copy of such Source Code\n    Form by reasonable means in a timely manner, at a charge no more\n    than the cost of distribution to the recipient; and\n\n(b) You may distribute such Executable Form under the terms of this\n    License, or sublicense it under different terms, provided that the\n    license for the Executable Form does not attempt to limit or alter\n    the recipients' rights in the Source Code Form under this License.\n\n3.3. Distribution of a Larger Work\n\nYou may create and distribute a Larger Work under terms of Your choice,\nprovided that You also comply with the requirements of this License for\nthe Covered Software. If the Larger Work is a combination of Covered\nSoftware with a work governed by one or more Secondary Licenses, and the\nCovered Software is not Incompatible With Secondary Licenses, this\nLicense permits You to additionally distribute such Covered Software\nunder the terms of such Secondary License(s), so that the recipient of\nthe Larger Work may, at their option, further distribute the Covered\nSoftware under the terms of either this License or such Secondary\nLicense(s).\n\n3.4. Notices\n\nYou may not remove or alter the substance of any license notices\n(including copyright notices, patent notices, disclaimers of warranty,\nor limitations of liability) contained within the Source Code Form of\nthe Covered Software, except that You may alter any license notices to\nthe extent required to remedy known factual inaccuracies.\n\n3.5. Application of Additional Terms\n\nYou may choose to offer, and to charge a fee for, warranty, support,\nindemnity or liability obligations to one or more recipients of Covered\nSoftware. However, You may do so only on Your own behalf, and not on\nbehalf of any Contributor. You must make it absolutely clear that any\nsuch warranty, support, indemnity, or liability obligation is offered by\nYou alone, and You hereby agree to indemnify every Contributor for any\nliability incurred by such Contributor as a result of warranty, support,\nindemnity or liability terms You offer. You may include additional\ndisclaimers of warranty and limitations of liability specific to any\njurisdiction.\n\n4. Inability to Comply Due to Statute or Regulation\n---------------------------------------------------\n\nIf it is impossible for You to comply with any of the terms of this\nLicense with respect to some or all of the Covered Software due to\nstatute, judicial order, or regulation then You must: (a) comply with\nthe terms of this License to the maximum extent possible; and (b)\ndescribe the limitations and the code they affect. Such description must\nbe placed in a text file included with all distributions of the Covered\nSoftware under this License. Except to the extent prohibited by statute\nor regulation, such description must be sufficiently detailed for a\nrecipient of ordinary skill to be able to understand it.\n\n5. Termination\n--------------\n\n5.1. The rights granted under this License will terminate automatically\nif You fail to comply with any of its terms. However, if You become\ncompliant, then the rights granted under this License from a particular\nContributor are reinstated (a) provisionally, unless and until such\nContributor explicitly and finally terminates Your grants, and (b) on an\nongoing basis, if such Contributor fails to notify You of the\nnon-compliance by some reasonable means prior to 60 days after You have\ncome back into compliance. Moreover, Your grants from a particular\nContributor are reinstated on an ongoing basis if such Contributor\nnotifies You of the non-compliance by some reasonable means, this is the\nfirst time You have received notice of non-compliance with this License\nfrom such Contributor, and You become compliant prior to 30 days after\nYour receipt of the notice.\n\n5.2. If You initiate litigation against any entity by asserting a patent\ninfringement claim (excluding declaratory judgment actions,\ncounter-claims, and cross-claims) alleging that a Contributor Version\ndirectly or indirectly infringes any patent, then the rights granted to\nYou by any and all Contributors for the Covered Software under Section\n2.1 of this License shall terminate.\n\n5.3. In the event of termination under Sections 5.1 or 5.2 above, all\nend user license agreements (excluding distributors and resellers) which\nhave been validly granted by You or Your distributors under this License\nprior to termination shall survive termination.\n\n************************************************************************\n*                                                                      *\n*  6. Disclaimer of Warranty                                           *\n*  -------------------------                                           *\n*                                                                      *\n*  Covered Software is provided under this License on an \"as is\"       *\n*  basis, without warranty of any kind, either expressed, implied, or  *\n*  statutory, including, without limitation, warranties that the       *\n*  Covered Software is free of defects, merchantable, fit for a        *\n*  particular purpose or non-infringing. The entire risk as to the     *\n*  quality and performance of the Covered Software is with You.        *\n*  Should any Covered Software prove defective in any respect, You     *\n*  (not any Contributor) assume the cost of any necessary servicing,   *\n*  repair, or correction. This disclaimer of warranty constitutes an   *\n*  essential part of this License. No use of any Covered Software is   *\n*  authorized under this License except under this disclaimer.         *\n*                                                                      *\n************************************************************************\n\n************************************************************************\n*                                                                      *\n*  7. Limitation of Liability                                          *\n*  --------------------------                                          *\n*                                                                      *\n*  Under no circumstances and under no legal theory, whether tort      *\n*  (including negligence), contract, or otherwise, shall any           *\n*  Contributor, or anyone who distributes Covered Software as          *\n*  permitted above, be liable to You for any direct, indirect,         *\n*  special, incidental, or consequential damages of any character      *\n*  including, without limitation, damages for lost profits, loss of    *\n*  goodwill, work stoppage, computer failure or malfunction, or any    *\n*  and all other commercial damages or losses, even if such party      *\n*  shall have been informed of the possibility of such damages. This   *\n*  limitation of liability shall not apply to liability for death or   *\n*  personal injury resulting from such party's negligence to the       *\n*  extent applicable law prohibits such limitation. Some               *\n*  jurisdictions do not allow the exclusion or limitation of           *\n*  incidental or consequential damages, so this exclusion and          *\n*  limitation may not apply to You.                                    *\n*                                                                      *\n************************************************************************\n\n8. Litigation\n-------------\n\nAny litigation relating to this License may be brought only in the\ncourts of a jurisdiction where the defendant maintains its principal\nplace of business and such litigation shall be governed by laws of that\njurisdiction, without reference to its conflict-of-law provisions.\nNothing in this Section shall prevent a party's ability to bring\ncross-claims or counter-claims.\n\n9. Miscellaneous\n----------------\n\nThis License represents the complete agreement concerning the subject\nmatter hereof. If any provision of this License is held to be\nunenforceable, such provision shall be reformed only to the extent\nnecessary to make it enforceable. Any law or regulation which provides\nthat the language of a contract shall be construed against the drafter\nshall not be used to construe this License against a Contributor.\n\n10. Versions of the License\n---------------------------\n\n10.1. New Versions\n\nMozilla Foundation is the license steward. Except as provided in Section\n10.3, no one other than the license steward has the right to modify or\npublish new versions of this License. Each version will be given a\ndistinguishing version number.\n\n10.2. Effect of New Versions\n\nYou may distribute the Covered Software under the terms of the version\nof the License under which You originally received the Covered Software,\nor under the terms of any subsequent version published by the license\nsteward.\n\n10.3. Modified Versions\n\nIf you create software not governed by this License, and you want to\ncreate a new license for such software, you may create and use a\nmodified version of this License if you rename the license and remove\nany references to the name of the license steward (except to note that\nsuch modified license differs from this License).\n\n10.4. Distributing Source Code Form that is Incompatible With Secondary\nLicenses\n\nIf You choose to distribute Source Code Form that is Incompatible With\nSecondary Licenses under the terms of this version of the License, the\nnotice described in Exhibit B of this License must be attached.\n\nExhibit A - Source Code Form License Notice\n-------------------------------------------\n\n  This Source Code Form is subject to the terms of the Mozilla Public\n  License, v. 2.0. If a copy of the MPL was not distributed with this\n  file, You can obtain one at http://mozilla.org/MPL/2.0/.\n\nIf it is not possible or desirable to put the notice in a particular\nfile, then You may include the notice in a location (such as a LICENSE\nfile in a relevant directory) where a recipient would be likely to look\nfor such a notice.\n\nYou may add additional accurate notices of copyright ownership.\n\nExhibit B - \"Incompatible With Secondary Licenses\" Notice\n---------------------------------------------------------\n\n  This Source Code Form is \"Incompatible With Secondary Licenses\", as\n  defined by the Mozilla Public License, v. 2.0.","ref":"license.html"},{"type":"extras","title":"Contributing","doc":"# Contributing to Uinta\n\nPlease take a moment to review this document in order to make the contribution\nprocess easy and effective for everyone involved!\nAlso make sure you read our [Code of Conduct](CODE_OF_CONDUCT.md) that outlines our commitment towards an open and welcoming environment.","ref":"contributing.html"},{"type":"extras","title":"Using the issue tracker - Contributing","doc":"Use the issues tracker for:\n\n* [Bug reports](#bug-reports)\n* [Submitting pull requests](#pull-requests)\n\nWe do our best to keep the issue tracker tidy and organized, making it useful\nfor everyone. For example, we classify open issues per perceived difficulty,\nmaking it easier for developers to [contribute to Uinta](#pull-requests).","ref":"contributing.html#using-the-issue-tracker"},{"type":"extras","title":"Bug reports - Contributing","doc":"A bug is either a _demonstrable problem_ that is caused by the code in the repository,\nor indicate missing, unclear, or misleading documentation. Good bug reports are extremely\nhelpful - thank you!\n\nGuidelines for bug reports:\n\n1. **Use the GitHub issue search** &mdash; check if the issue has already been\n   reported.\n\n2. **Check if the issue has been fixed** &mdash; try to reproduce it using the\n   `master` branch in the repository.\n\n3. **Isolate and report the problem** &mdash; ideally create a reduced test\n   case.\n\nPlease try to be as detailed as possible in your report. Include information about\nyour Operating System, as well as your Erlang, Elixir and Uinta versions. Please provide steps to\nreproduce the issue as well as the outcome you were expecting! All these details\nwill help developers to fix any potential bugs.\n\nExample:\n\n> Short and descriptive example bug report title\n>\n> A summary of the issue and the environment in which it occurs. If suitable,\n> include the steps required to reproduce the bug.\n>\n> 1. This is the first step\n> 2. This is the second step\n> 3. Further steps, etc.\n>\n> ` ` - a link to the reduced test case (e.g. a GitHub Gist)\n>\n> Any other information you want to share that is relevant to the issue being\n> reported. This might include the lines of code that you have identified as\n> causing the bug, and potential solutions (and your opinions on their\n> merits).","ref":"contributing.html#bug-reports"},{"type":"extras","title":"Contributing Documentation - Contributing","doc":"Code documentation (`@doc`, `@moduledoc`, `@typedoc`) has a special convention:\nthe first paragraph is considered to be a short summary.\n\nFor functions, macros and callbacks say what it will do. For example write\nsomething like:\n\n```elixir\n@doc \"\"\"\nMarks the given value as HTML safe.\n\"\"\"\ndef safe({:safe, value}), do: {:safe, value}\n```\n\nFor modules, protocols and types say what it is. For example write\nsomething like:\n\n```elixir\ndefmodule MyModule do\n  @moduledoc \"\"\"\n  Conveniences for working HTML strings and templates.\n  ...\n  \"\"\"\n```\n\nKeep in mind that the first paragraph might show up in a summary somewhere, long\ntexts in the first paragraph create very ugly summaries. As a rule of thumb\nanything longer than 80 characters is too long.\n\nTry to keep unnecessary details out of the first paragraph, it's only there to\ngive a user a quick idea of what the documented \"thing\" does/is. The rest of the\ndocumentation string can contain the details, for example when a value and when\n`nil` is returned.\n\nIf possible include examples, preferably in a form that works with doctests.\nThis makes it easy to test the examples so that they don't go stale and examples\nare often a great help in explaining what a function does.","ref":"contributing.html#contributing-documentation"},{"type":"extras","title":"Pull requests - Contributing","doc":"Good pull requests - patches, improvements, new features - are a fantastic\nhelp. They should remain focused in scope and avoid containing unrelated\ncommits.\n\n**IMPORTANT**: By submitting a patch, you agree that your work will be\nlicensed under the license used by the project.\n\nIf you have any large pull request in mind (e.g. implementing features,\nrefactoring code, etc), **please ask first** otherwise you risk spending\na lot of time working on something that the project's developers might\nnot want to merge into the project.\n\nPlease adhere to the coding conventions in the project (indentation,\naccurate comments, etc.) and don't forget to add your own tests and\ndocumentation. When working with git, we recommend the following process\nin order to craft an excellent pull request:\n\n1. [Fork](https://help.github.com/articles/fork-a-repo/) the project, clone your fork,\n   and configure the remotes:\n\n   ```bash\n   # Clone your fork of the repo into the current directory\n   git clone https://github.com/ /uinta\n\n   # Navigate to the newly cloned directory\n   cd uinta\n\n   # Assign the original repo to a remote called \"upstream\"\n   git remote add upstream https://github.com/podium/uinta\n   ```\n\n2. If you cloned a while ago, get the latest changes from upstream, and update your fork:\n\n   ```bash\n   git checkout master\n   git pull upstream master\n   git push\n   ```\n\n3. Create a new topic branch (off of `master`) to contain your feature, change,\n   or fix.\n\n   **IMPORTANT**: Making changes in `master` is discouraged. You should always\n   keep your local `master` in sync with upstream `master` and make your\n   changes in topic branches.\n\n   ```bash\n   git checkout -b  \n   ```\n\n4. Commit your changes in logical chunks. Keep your commit messages organized,\n   with a short description in the first line and more detailed information on\n   the following lines. Feel free to use Git's\n   [interactive rebase](https://help.github.com/articles/about-git-rebase/)\n   feature to tidy up your commits before making them public.\n\n5. Make sure all the tests are still passing.\n\n   ```bash\n   mix test\n   ```\n\n6. Push your topic branch up to your fork:\n\n   ```bash\n   git push origin  \n   ```\n\n7. [Open a Pull Request](https://help.github.com/articles/about-pull-requests/)\n    with a clear title and description.\n\n8. If you haven't updated your pull request for a while, you should consider\n   rebasing on master and resolving any conflicts.\n\n   **IMPORTANT**: _Never ever_ merge upstream `master` into your branches. You\n   should always `git rebase` on `master` to bring your changes up to date when\n   necessary.\n\n   ```bash\n   git checkout master\n   git pull upstream master\n   git checkout  \n   git rebase master\n   ```\n\nThank you for your contributions!","ref":"contributing.html#pull-requests"},{"type":"extras","title":"Guides - Contributing","doc":"These Guides aim to be inclusive. We use \"we\" and \"our\" instead of \"you\" and\n\"your\" to foster this sense of inclusion.\n\nIdeally there is something for everybody in each guide, from beginner to expert.\nThis is hard, maybe impossible. When we need to compromise, we do so on behalf\nof beginning users because expert users have more tools at their disposal to\nhelp themselves.\n\nThe general pattern we use for presenting information is to first introduce a\nsmall, discrete topic, then write a small amount of code to demonstrate the\nconcept, then verify that the code worked.\n\nIn this way, we build from small, easily digestible concepts into more complex\nones. The shorter this cycle is, as long as the information is still clear and\ncomplete, the better.\n\nFor formatting the guides:\n\n- We use the `elixir` code fence for all module code.\n- We use the `iex` for IEx sessions.\n- We use the `console` code fence for shell commands.\n- We use the `html` code fence for html templates, even if there is elixir code\n  in the template.\n- We use backticks for filenames and directory paths.\n- We use backticks for module names, function names, and variable names.\n- Documentation line length should hard wrapped at around 100 characters if possible.","ref":"contributing.html#guides"},{"type":"extras","title":"Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Code of Conduct","doc":"We as members, contributors, and leaders pledge to make participation in our\ncommunity a harassment-free experience for everyone, regardless of age, body\nsize, visible or invisible disability, ethnicity, sex characteristics, gender\nidentity and expression, level of experience, education, socio-economic status,\nnationality, personal appearance, race, caste, color, religion, or sexual\nidentity and orientation.\n\nWe pledge to act and interact in ways that contribute to an open, welcoming,\ndiverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Code of Conduct","doc":"Examples of behavior that contributes to a positive environment for our\ncommunity include:\n\n* Demonstrating empathy and kindness toward other people\n* Being respectful of differing opinions, viewpoints, and experiences\n* Giving and gracefully accepting constructive feedback\n* Accepting responsibility and apologizing to those affected by our mistakes,\n  and learning from the experience\n* Focusing on what is best not just for us as individuals, but for the overall\n  community\n\nExamples of unacceptable behavior include:\n\n* The use of sexualized language or imagery, and sexual attention or advances of\n  any kind\n* Trolling, insulting or derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or email address,\n  without their explicit permission\n* Other conduct which could reasonably be considered inappropriate in a\n  professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Enforcement Responsibilities - Code of Conduct","doc":"Community leaders are responsible for clarifying and enforcing our standards of\nacceptable behavior and will take appropriate and fair corrective action in\nresponse to any behavior that they deem inappropriate, threatening, offensive,\nor harmful.\n\nCommunity leaders have the right and responsibility to remove, edit, or reject\ncomments, commits, code, wiki edits, issues, and other contributions that are\nnot aligned to this Code of Conduct, and will communicate reasons for moderation\ndecisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities"},{"type":"extras","title":"Scope - Code of Conduct","doc":"This Code of Conduct applies within all community spaces, and also applies when\nan individual is officially representing the community in public spaces.\nExamples of representing our community include using an official e-mail address,\nposting via an official social media account, or acting as an appointed\nrepresentative at an online or offline event.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be\nreported to the community leaders responsible for enforcement at\nengineering@therealreal.com. All complaints will be reviewed and investigated\npromptly and fairly.\n\nAll community leaders are obligated to respect the privacy and security of the\nreporter of any incident.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Enforcement Guidelines - Code of Conduct","doc":"Community leaders will follow these Community Impact Guidelines in determining\nthe consequences for any action they deem in violation of this Code of Conduct:","ref":"code_of_conduct.html#enforcement-guidelines"},{"type":"extras","title":"1. Correction - Code of Conduct","doc":"**Community Impact**: Use of inappropriate language or other behavior deemed\nunprofessional or unwelcome in the community.\n\n**Consequence**: A private, written warning from community leaders, providing\nclarity around the nature of the violation and an explanation of why the\nbehavior was inappropriate. A public apology may be requested.","ref":"code_of_conduct.html#1-correction"},{"type":"extras","title":"2. Warning - Code of Conduct","doc":"**Community Impact**: A violation through a single incident or series of\nactions.\n\n**Consequence**: A warning with consequences for continued behavior. No\ninteraction with the people involved, including unsolicited interaction with\nthose enforcing the Code of Conduct, for a specified period of time. This\nincludes avoiding interactions in community spaces as well as external channels\nlike social media. Violating these terms may lead to a temporary or permanent\nban.","ref":"code_of_conduct.html#2-warning"},{"type":"extras","title":"3. Temporary Ban - Code of Conduct","doc":"**Community Impact**: A serious violation of community standards, including\nsustained inappropriate behavior.\n\n**Consequence**: A temporary ban from any sort of interaction or public\ncommunication with the community for a specified period of time. No public or\nprivate interaction with the people involved, including unsolicited interaction\nwith those enforcing the Code of Conduct, is allowed during this period.\nViolating these terms may lead to a permanent ban.","ref":"code_of_conduct.html#3-temporary-ban"},{"type":"extras","title":"4. Permanent Ban - Code of Conduct","doc":"**Community Impact**: Demonstrating a pattern of violation of community\nstandards, including sustained inappropriate behavior, harassment of an\nindividual, or aggression toward or disparagement of classes of individuals.\n\n**Consequence**: A permanent ban from any sort of public interaction within the\ncommunity.","ref":"code_of_conduct.html#4-permanent-ban"},{"type":"extras","title":"Attribution - Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage],\nversion 2.1, available at\n[https://www.contributor-covenant.org/version/2/1/code_of_conduct.html][v2.1].\n\nCommunity Impact Guidelines were inspired by\n[Mozilla's code of conduct enforcement ladder][Mozilla CoC].\n\nFor answers to common questions about this code of conduct, see the FAQ at\n[https://www.contributor-covenant.org/faq][FAQ]. Translations are available at\n[https://www.contributor-covenant.org/translations][translations].\n\n[homepage]: https://www.contributor-covenant.org\n[v2.1]: https://www.contributor-covenant.org/version/2/1/code_of_conduct.html\n[Mozilla CoC]: https://github.com/mozilla/diversity\n[FAQ]: https://www.contributor-covenant.org/faq\n[translations]: https://www.contributor-covenant.org/translations","ref":"code_of_conduct.html#attribution"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}